Index: /trunk/src/VBox/Main/src-client/DisplayImpl.cpp
===================================================================
--- /trunk/src/VBox/Main/src-client/DisplayImpl.cpp	(revision 38965)
+++ /trunk/src/VBox/Main/src-client/DisplayImpl.cpp	(revision 38966)
@@ -168,5 +168,5 @@
     }
 
-    LogFlowFunc(("%dx%d -> %dx%d\n", cx, cy, cxThumbnail, cyThumbnail));
+    LogRelFlowFunc(("%dx%d -> %dx%d\n", cx, cy, cxThumbnail, cyThumbnail));
 
     cbThumbnail = cxThumbnail * 4 * cyThumbnail;
@@ -319,5 +319,5 @@
         AssertRCBreak(rc);
 
-        LogFlowFunc(("[%d] type %d, size %d bytes\n", i, typeOfBlock, cbBlock));
+        LogRelFlowFunc(("[%d] type %d, size %d bytes\n", i, typeOfBlock, cbBlock));
 
         /* Note: displaySSMSaveScreenshot writes size of a block = 8 and
@@ -414,5 +414,5 @@
 HRESULT Display::init (Console *aParent)
 {
-    LogFlowThisFunc(("aParent=%p\n", aParent));
+    LogRelFlowFunc(("this=%p: aParent=%p\n", this, aParent));
 
     ComAssertRet(aParent, E_INVALIDARG);
@@ -490,5 +490,5 @@
 void Display::uninit()
 {
-    LogFlowThisFunc(("\n"));
+    LogRelFlowFunc(("this=%p\n", this));
 
     /* Enclose the state transition Ready->InUninit->NotReady */
@@ -580,5 +580,5 @@
                    )
             {
-                LogFlowFunc(("Machine is running.\n"));
+                LogRelFlowFunc(("Machine is running.\n"));
 
                 mfMachineRunning = true;
@@ -616,5 +616,5 @@
     if (!finished)
     {
-        LogFlowFunc (("External framebuffer wants us to wait!\n"));
+        LogRelFlowFunc (("External framebuffer wants us to wait!\n"));
         return VINF_VGA_RESIZE_IN_PROGRESS;
     }
@@ -733,5 +733,5 @@
 void Display::handleResizeCompletedEMT (void)
 {
-    LogFlowFunc(("\n"));
+    LogRelFlowFunc(("\n"));
 
     unsigned uScreenId;
@@ -806,5 +806,5 @@
                 pFBInfo->pFramebuffer->NotifyUpdate(0, 0, pFBInfo->w, pFBInfo->h);
         }
-        LogFlow(("[%d]: default format %d\n", uScreenId, pFBInfo->fDefaultFormat));
+        LogRelFlow(("[%d]: default format %d\n", uScreenId, pFBInfo->fDefaultFormat));
 
 #ifdef DEBUG_sunlover
@@ -821,5 +821,5 @@
 
         /* Inform VRDP server about the change of display parameters. */
-        LogFlowFunc (("Calling VRDP\n"));
+        LogRelFlowFunc (("Calling VRDP\n"));
         mParent->consoleVRDPServer()->SendResize();
 
@@ -989,5 +989,5 @@
     AssertPtrReturnVoid(px2);
     AssertPtrReturnVoid(py2);
-    LogFlowFunc(("\n"));
+    LogRelFlowFunc(("\n"));
 
     if (!mpDrv)
@@ -1298,5 +1298,5 @@
                                      DISPLAYFBINFO *pFBInfo)
 {
-    LogFlowFunc(("HGSMI[%d]: %p\n", uScreenId, pFBInfo->pVBVAHostFlags));
+    LogRelFlowFunc(("HGSMI[%d]: %p\n", uScreenId, pFBInfo->pVBVAHostFlags));
 
     if (pFBInfo->pVBVAHostFlags)
@@ -1317,5 +1317,5 @@
         ASMAtomicWriteU32(&pFBInfo->pVBVAHostFlags->u32SupportedOrders, fu32SupportedOrders);
 
-        LogFlowFunc(("    fu32HostEvents = 0x%08X, fu32SupportedOrders = 0x%08X\n", fu32HostEvents, fu32SupportedOrders));
+        LogRelFlowFunc(("    fu32HostEvents = 0x%08X, fu32SupportedOrders = 0x%08X\n", fu32HostEvents, fu32SupportedOrders));
     }
 }
@@ -1376,5 +1376,5 @@
      * acceleration after a mode change.
      */
-    LogFlowFunc (("mfVideoAccelEnabled = %d, fEnable = %d, pVbvaMemory = %p\n",
+    LogRelFlowFunc (("mfVideoAccelEnabled = %d, fEnable = %d, pVbvaMemory = %p\n",
                   mfVideoAccelEnabled, fEnable, pVbvaMemory));
 
@@ -1393,5 +1393,5 @@
         Assert (!mfVideoAccelEnabled);
 
-        LogFlowFunc (("Machine is not yet running.\n"));
+        LogRelFlowFunc (("Machine is not yet running.\n"));
 
         if (fEnable)
@@ -1461,5 +1461,5 @@
     }
 
-    LogFlowFunc (("VideoAccelEnable: rc = %Rrc.\n", rc));
+    LogRelFlowFunc (("VideoAccelEnable: rc = %Rrc.\n", rc));
 
     return rc;
@@ -1470,5 +1470,5 @@
 void Display::VideoAccelVRDP (bool fEnable)
 {
-    LogFlowFunc(("fEnable = %d\n", fEnable));
+    LogRelFlowFunc(("fEnable = %d\n", fEnable));
 
     vbvaLock();
@@ -1725,5 +1725,5 @@
             if (!dst)
             {
-                LogFlowFunc (("could not allocate %d bytes from heap!!!\n", cbRecord));
+                LogRelFlowFunc (("could not allocate %d bytes from heap!!!\n", cbRecord));
                 mpVbvaMemory->off32Data = (mpVbvaMemory->off32Data + cbRecord) % VBVA_RING_BUFFER_SIZE;
                 return false;
@@ -1980,5 +1980,5 @@
     ULONG *aWidth, ULONG *aHeight, ULONG *aBitsPerPixel)
 {
-    LogFlowFunc (("aScreenId = %d\n", aScreenId));
+    LogRelFlowFunc (("aScreenId = %d\n", aScreenId));
 
     AutoCaller autoCaller(this);
@@ -2025,5 +2025,5 @@
     IFramebuffer *aFramebuffer)
 {
-    LogFlowFunc (("\n"));
+    LogRelFlowFunc (("\n"));
 
     if (aFramebuffer != NULL)
@@ -2088,5 +2088,5 @@
     IFramebuffer **aFramebuffer, LONG *aXOrigin, LONG *aYOrigin)
 {
-    LogFlowFunc (("aScreenId = %d\n", aScreenId));
+    LogRelFlowFunc (("aScreenId = %d\n", aScreenId));
 
     CheckComArgOutPointerValid(aFramebuffer);
@@ -2311,5 +2311,5 @@
         {
             /* Scale. */
-            LogFlowFunc(("SCALE: %dx%d -> %dx%d\n", cx, cy, width, height));
+            LogRelFlowFunc(("SCALE: %dx%d -> %dx%d\n", cx, cy, width, height));
 
             uint8_t *dst = address;
@@ -2350,6 +2350,5 @@
     //  within the Console lock to make it atomic).
 
-    LogFlowFuncEnter();
-    LogFlowFunc (("address=%p, width=%d, height=%d\n",
+    LogRelFlowFunc (("address=%p, width=%d, height=%d\n",
                   address, width, height));
 
@@ -2376,5 +2375,5 @@
     HRESULT rc = S_OK;
 
-    LogFlowFunc (("Sending SCREENSHOT request\n"));
+    LogRelFlowFunc (("Sending SCREENSHOT request\n"));
 
     /* Leave lock because other thread (EMT) is called and it may initiate a resize
@@ -2397,6 +2396,5 @@
                       tr("Could not take a screenshot (%Rrc)"), vrc);
 
-    LogFlowFunc (("rc=%08X\n", rc));
-    LogFlowFuncLeave();
+    LogRelFlowFunc (("rc=%08X\n", rc));
     return rc;
 }
@@ -2405,6 +2403,5 @@
                                              ComSafeArrayOut(BYTE, aScreenData))
 {
-    LogFlowFuncEnter();
-    LogFlowFunc (("width=%d, height=%d\n",
+    LogRelFlowFunc (("width=%d, height=%d\n",
                   width, height));
 
@@ -2431,5 +2428,5 @@
     HRESULT rc = S_OK;
 
-    LogFlowFunc (("Sending SCREENSHOT request\n"));
+    LogRelFlowFunc (("Sending SCREENSHOT request\n"));
 
     /* Leave lock because other thread (EMT) is called and it may initiate a resize
@@ -2476,6 +2473,5 @@
     RTMemFree(pu8Data);
 
-    LogFlowFunc (("rc=%08X\n", rc));
-    LogFlowFuncLeave();
+    LogRelFlowFunc (("rc=%08X\n", rc));
     return rc;
 }
@@ -2484,6 +2480,5 @@
                                              ComSafeArrayOut(BYTE, aScreenData))
 {
-    LogFlowFuncEnter();
-    LogFlowFunc (("width=%d, height=%d\n",
+    LogRelFlowFunc (("width=%d, height=%d\n",
                   width, height));
 
@@ -2510,5 +2505,5 @@
     HRESULT rc = S_OK;
 
-    LogFlowFunc (("Sending SCREENSHOT request\n"));
+    LogRelFlowFunc (("Sending SCREENSHOT request\n"));
 
     /* Leave lock because other thread (EMT) is called and it may initiate a resize
@@ -2551,6 +2546,5 @@
     RTMemFree(pu8Data);
 
-    LogFlowFunc (("rc=%08X\n", rc));
-    LogFlowFuncLeave();
+    LogRelFlowFunc (("rc=%08X\n", rc));
     return rc;
 }
@@ -2665,6 +2659,5 @@
     //  within the Console lock to make it atomic).
 
-    LogFlowFuncEnter();
-    LogFlowFunc (("address=%p, x=%d, y=%d, width=%d, height=%d\n",
+    LogRelFlowFunc (("address=%p, x=%d, y=%d, width=%d, height=%d\n",
                   (void *)address, x, y, width, height));
 
@@ -2713,6 +2706,5 @@
 //    }
 
-    LogFlowFunc (("rc=%08X\n", rc));
-    LogFlowFuncLeave();
+    LogRelFlowFunc (("rc=%08X\n", rc));
     return rc;
 }
@@ -2792,5 +2784,5 @@
 STDMETHODIMP Display::InvalidateAndUpdate()
 {
-    LogFlowFuncEnter();
+    LogRelFlowFunc(("\n"));
 
     AutoCaller autoCaller(this);
@@ -2806,5 +2798,5 @@
     HRESULT rc = S_OK;
 
-    LogFlowFunc (("Sending DPYUPDATE request\n"));
+    LogRelFlowFunc (("Sending DPYUPDATE request\n"));
 
     /* Have to leave the lock when calling EMT.  */
@@ -2820,6 +2812,5 @@
                       tr("Could not invalidate and update the screen (%Rrc)"), rcVBox);
 
-    LogFlowFunc (("rc=%08X\n", rc));
-    LogFlowFuncLeave();
+    LogRelFlowFunc (("rc=%08X\n", rc));
     return rc;
 }
@@ -2833,5 +2824,5 @@
 STDMETHODIMP Display::ResizeCompleted(ULONG aScreenId)
 {
-    LogFlowFunc (("\n"));
+    LogRelFlowFunc (("\n"));
 
     /// @todo (dmik) can we AutoWriteLock alock(this COMMA_LOCKVAL_SRC_POS); here?
@@ -2879,5 +2870,5 @@
 void Display::updateDisplayData(void)
 {
-    LogFlowFunc (("\n"));
+    LogRelFlowFunc (("\n"));
 
     /* the driver might not have been constructed yet */
@@ -2936,5 +2927,5 @@
         mpDrv->IConnector.cy = 0;
     }
-    LogFlowFunc (("leave\n"));
+    LogRelFlowFunc (("leave\n"));
 }
 
@@ -2975,5 +2966,5 @@
                                               unsigned uScreenId)
 {
-    LogFlowFunc (("uScreenId = %d\n", uScreenId));
+    LogRelFlowFunc (("uScreenId = %d\n", uScreenId));
 
     AssertReturn(that, VERR_INVALID_PARAMETER);
@@ -3033,5 +3024,5 @@
     }
 
-    LogFlowFunc (("leave\n"));
+    LogRelFlowFunc (("leave\n"));
     return VINF_SUCCESS;
 }
@@ -3047,5 +3038,5 @@
     PDRVMAINDISPLAY pDrv = PDMIDISPLAYCONNECTOR_2_MAINDISPLAY(pInterface);
 
-    LogFlowFunc (("bpp %d, pvVRAM %p, cbLine %d, cx %d, cy %d\n",
+    LogRelFlowFunc (("bpp %d, pvVRAM %p, cbLine %d, cx %d, cy %d\n",
                   bpp, pvVRAM, cbLine, cx, cy));
 
@@ -3109,5 +3100,5 @@
         if (u32ResizeStatus == ResizeStatus_UpdateDisplayData)
         {
-            LogFlowFunc (("ResizeStatus_UpdateDisplayData %d\n", uScreenId));
+            LogRelFlowFunc (("ResizeStatus_UpdateDisplayData %d\n", uScreenId));
             fNoUpdate = true; /* Always set it here, because pfnUpdateDisplayAll can cause a new resize. */
             /* The framebuffer was resized and display data need to be updated. */
@@ -3126,5 +3117,5 @@
         {
             /* The framebuffer is being resized. Do not call the VGA device back. Immediately return. */
-            LogFlowFunc (("ResizeStatus_InProcess\n"));
+            LogRelFlowFunc (("ResizeStatus_InProcess\n"));
             fNoUpdate = true;
             continue;
@@ -3187,5 +3178,5 @@
     PDRVMAINDISPLAY pDrv = PDMIDISPLAYCONNECTOR_2_MAINDISPLAY(pInterface);
 
-    LogFlowFunc (("\n"));
+    LogRelFlowFunc (("\n"));
 
     /* Disable VBVA mode. */
@@ -3202,5 +3193,5 @@
     PDRVMAINDISPLAY pDrv = PDMIDISPLAYCONNECTOR_2_MAINDISPLAY(pInterface);
 
-    LogFlowFunc (("fEnabled=%d\n", fEnabled));
+    LogRelFlowFunc (("fEnabled=%d\n", fEnabled));
 
     NOREF(fEnabled);
@@ -3276,5 +3267,5 @@
                  pFBInfo->u32InformationSize = pDisplay->u32InformationSize;
 
-                 LogFlow(("VBOX_VIDEO_INFO_TYPE_DISPLAY: %d: at 0x%08X, size 0x%08X, info 0x%08X\n", pDisplay->u32Index, pDisplay->u32Offset, pDisplay->u32FramebufferSize, pDisplay->u32InformationSize));
+                 LogRelFlow(("VBOX_VIDEO_INFO_TYPE_DISPLAY: %d: at 0x%08X, size 0x%08X, info 0x%08X\n", pDisplay->u32Index, pDisplay->u32Offset, pDisplay->u32FramebufferSize, pDisplay->u32InformationSize));
              }
              else if (pHdr->u8Type == VBOX_VIDEO_INFO_TYPE_QUERY_CONF32)
@@ -3379,5 +3370,5 @@
             pFBInfo->h = pScreen->u16Height;
 
-            LogFlow(("VBOX_VIDEO_INFO_TYPE_SCREEN: (%p) %d: at %d,%d, linesize 0x%X, size %dx%d, bpp %d, flags 0x%02X\n",
+            LogRelFlow(("VBOX_VIDEO_INFO_TYPE_SCREEN: (%p) %d: at %d,%d, linesize 0x%X, size %dx%d, bpp %d, flags 0x%02X\n",
                      pHdr, uScreenId, pScreen->xOrigin, pScreen->yOrigin, pScreen->u32LineSize, pScreen->u16Width, pScreen->u16Height, pScreen->bitsPerPixel, pScreen->u8Flags));
 
@@ -3574,5 +3565,5 @@
 DECLCALLBACK(int) Display::displayVBVAEnable(PPDMIDISPLAYCONNECTOR pInterface, unsigned uScreenId, PVBVAHOSTFLAGS pHostFlags)
 {
-    LogFlowFunc(("uScreenId %d\n", uScreenId));
+    LogRelFlowFunc(("uScreenId %d\n", uScreenId));
 
     PDRVMAINDISPLAY pDrv = PDMIDISPLAYCONNECTOR_2_MAINDISPLAY(pInterface);
@@ -3589,5 +3580,5 @@
 DECLCALLBACK(void) Display::displayVBVADisable(PPDMIDISPLAYCONNECTOR pInterface, unsigned uScreenId)
 {
-    LogFlowFunc(("uScreenId %d\n", uScreenId));
+    LogRelFlowFunc(("uScreenId %d\n", uScreenId));
 
     PDRVMAINDISPLAY pDrv = PDMIDISPLAYCONNECTOR_2_MAINDISPLAY(pInterface);
@@ -3780,5 +3771,5 @@
 DECLCALLBACK(int) Display::displayVBVAResize(PPDMIDISPLAYCONNECTOR pInterface, const PVBVAINFOVIEW pView, const PVBVAINFOSCREEN pScreen, void *pvVRAM)
 {
-    LogFlowFunc(("pScreen %p, pvVRAM %p\n", pScreen, pvVRAM));
+    LogRelFlowFunc(("pScreen %p, pvVRAM %p\n", pScreen, pvVRAM));
 
     PDRVMAINDISPLAY pDrv = PDMIDISPLAYCONNECTOR_2_MAINDISPLAY(pInterface);
@@ -3888,5 +3879,5 @@
         {
             /* VRDP server still need this notification. */
-            LogFlowFunc (("Calling VRDP\n"));
+            LogRelFlowFunc (("Calling VRDP\n"));
             pThis->mParent->consoleVRDPServer()->SendResize();
         }
@@ -3951,5 +3942,5 @@
 {
     PDRVMAINDISPLAY pData = PDMINS_2_DATA(pDrvIns, PDRVMAINDISPLAY);
-    LogFlowFunc (("iInstance=%d\n", pDrvIns->iInstance));
+    LogRelFlowFunc (("iInstance=%d\n", pDrvIns->iInstance));
     PDMDRV_CHECK_VERSIONS_RETURN_VOID(pDrvIns);
 
@@ -3979,5 +3970,5 @@
 {
     PDRVMAINDISPLAY pData = PDMINS_2_DATA(pDrvIns, PDRVMAINDISPLAY);
-    LogFlowFunc (("iInstance=%d\n", pDrvIns->iInstance));
+    LogRelFlowFunc (("iInstance=%d\n", pDrvIns->iInstance));
     PDMDRV_CHECK_VERSIONS_RETURN(pDrvIns);
 