Index: trunk/src/VBox/Runtime/common/dbg/dbgas.cpp
===================================================================
--- trunk/src/VBox/Runtime/common/dbg/dbgas.cpp	(revision 39029)
+++ trunk/src/VBox/Runtime/common/dbg/dbgas.cpp	(revision 39032)
@@ -758,5 +758,5 @@
      */
     PAVLPVNODECORE pNode = RTAvlPVRemove(&pDbgAs->ModTree, pMod->Core.Key);
-    Assert(pNode == &pMod->Core);
+    Assert(pNode == &pMod->Core); NOREF(pNode);
 
     /*
@@ -793,5 +793,5 @@
     /* remove from the tree */
     PAVLRUINTPTRNODECORE pNode = RTAvlrUIntPtrRemove(&pDbgAs->MapTree, pMap->Core.Key);
-    Assert(pNode == &pMap->Core);
+    Assert(pNode == &pMap->Core); NOREF(pNode);
 
     /* unlink */
Index: trunk/src/VBox/Runtime/common/dbg/dbgmoddwarf.cpp
===================================================================
--- trunk/src/VBox/Runtime/common/dbg/dbgmoddwarf.cpp	(revision 39029)
+++ trunk/src/VBox/Runtime/common/dbg/dbgmoddwarf.cpp	(revision 39032)
@@ -1966,4 +1966,5 @@
                                 uint64_t uSeg = rtDwarfCursor_GetVarSizedU(pCursor, cbInstr - 1, UINT64_MAX);
                                 Log2(("%08x: DW_LNE_set_segment: %ll#x - Watcom Extension\n", offOpCode, uSeg));
+                                NOREF(uSeg);
                                 /** @todo make use of this? */
                             }
Index: trunk/src/VBox/Runtime/common/ldr/ldrELFRelocatable.cpp.h
===================================================================
--- trunk/src/VBox/Runtime/common/ldr/ldrELFRelocatable.cpp.h	(revision 39029)
+++ trunk/src/VBox/Runtime/common/ldr/ldrELFRelocatable.cpp.h	(revision 39032)
@@ -692,5 +692,5 @@
     NOREF(pvBits);
 
-    return VERR_NOT_IMPLEMENTED;
+    return VERR_NOT_IMPLEMENTED; NOREF(pModElf);
 }
 
@@ -701,5 +701,5 @@
     PRTLDRMODELF pModElf = (PRTLDRMODELF)pMod;
 
-    return VERR_NOT_IMPLEMENTED;
+    return VERR_NOT_IMPLEMENTED; NOREF(pModElf);
 }
 
@@ -711,5 +711,5 @@
     PRTLDRMODELF pModElf = (PRTLDRMODELF)pMod;
 
-    return VERR_NOT_IMPLEMENTED;
+    return VERR_NOT_IMPLEMENTED; NOREF(pModElf);
 }
 
@@ -720,5 +720,5 @@
     PRTLDRMODELF pModElf = (PRTLDRMODELF)pMod;
 
-    return VERR_NOT_IMPLEMENTED;
+    return VERR_NOT_IMPLEMENTED; NOREF(pModElf);
 }
 
@@ -730,5 +730,5 @@
     PRTLDRMODELF pModElf = (PRTLDRMODELF)pMod;
 
-    return VERR_NOT_IMPLEMENTED;
+    return VERR_NOT_IMPLEMENTED; NOREF(pModElf);
 }
 
@@ -740,5 +740,5 @@
     PRTLDRMODELF pModElf = (PRTLDRMODELF)pMod;
 
-    return VERR_NOT_IMPLEMENTED;
+    return VERR_NOT_IMPLEMENTED; NOREF(pModElf);
 }
 
Index: trunk/src/VBox/Runtime/common/misc/circbuf.cpp
===================================================================
--- trunk/src/VBox/Runtime/common/misc/circbuf.cpp	(revision 39029)
+++ trunk/src/VBox/Runtime/common/misc/circbuf.cpp	(revision 39032)
@@ -206,5 +206,4 @@
     pBuf->offWrite = (pBuf->offWrite + cbSize) % pBuf->cbBuf;
 
-    size_t cbOldIgnored = 0;
     ASMAtomicAddZ(&pBuf->cbUsed, cbSize);
 }
Index: trunk/src/VBox/Runtime/common/misc/getopt.cpp
===================================================================
--- trunk/src/VBox/Runtime/common/misc/getopt.cpp	(revision 39029)
+++ trunk/src/VBox/Runtime/common/misc/getopt.cpp	(revision 39032)
@@ -688,5 +688,4 @@
 
             uint32_t uIndex;
-            char *pszRet = NULL;
             if (RTStrToUInt32Full(&pszArgThis[cchLong], 10, &uIndex) == VINF_SUCCESS)
                 pState->uIndex = uIndex;
Index: trunk/src/VBox/Runtime/common/misc/req.cpp
===================================================================
--- trunk/src/VBox/Runtime/common/misc/req.cpp	(revision 39029)
+++ trunk/src/VBox/Runtime/common/misc/req.cpp	(revision 39032)
@@ -453,5 +453,4 @@
 RTDECL(int) RTReqAlloc(PRTREQQUEUE pQueue, PRTREQ *ppReq, RTREQTYPE enmType)
 {
-    RT_EXPORT_SYMBOL(RTReqAlloc);
     /*
      * Validate input.
@@ -573,4 +572,5 @@
     return VINF_SUCCESS;
 }
+RT_EXPORT_SYMBOL(RTReqAlloc);
 
 
Index: trunk/src/VBox/Runtime/common/path/RTPathAppendEx.cpp
===================================================================
--- trunk/src/VBox/Runtime/common/path/RTPathAppendEx.cpp	(revision 39029)
+++ trunk/src/VBox/Runtime/common/path/RTPathAppendEx.cpp	(revision 39032)
@@ -130,5 +130,4 @@
      * Balance slashes and check for buffer overflow.
      */
-    bool fAddSlash = false;
     if (!RTPATH_IS_SLASH(pszPathEnd[-1]))
     {
Index: trunk/src/VBox/Runtime/common/string/RTStrCatP.cpp
===================================================================
--- trunk/src/VBox/Runtime/common/string/RTStrCatP.cpp	(revision 39029)
+++ trunk/src/VBox/Runtime/common/string/RTStrCatP.cpp	(revision 39032)
@@ -5,5 +5,5 @@
 
 /*
- * Copyright (C) 2010 Oracle Corporation
+ * Copyright (C) 2010-2011 Oracle Corporation
  *
  * This file is part of VirtualBox Open Source Edition (OSE), as
@@ -39,9 +39,10 @@
      * a copy operation.
      */
-    size_t  cbDst  = *pcbDst;
-    char   *pszDst = RTStrEnd(*ppszDst, *pcbDst);
+    char   *pszDstOrg = *ppszDst;
+    size_t  cbDst     = *pcbDst;
+    char   *pszDst    = RTStrEnd(pszDstOrg, cbDst);
     AssertReturn(pszDst, VERR_INVALID_PARAMETER);
-    *pcbDst -= pszDst - *ppszDst;
     *ppszDst = pszDst;
+    *pcbDst  = cbDst - (pszDst - pszDstOrg);
 
     return RTStrCopyP(ppszDst, pcbDst, pszSrc);
Index: trunk/src/VBox/Runtime/common/vfs/vfsmemory.cpp
===================================================================
--- trunk/src/VBox/Runtime/common/vfs/vfsmemory.cpp	(revision 39029)
+++ trunk/src/VBox/Runtime/common/vfs/vfsmemory.cpp	(revision 39032)
@@ -548,7 +548,5 @@
                                               uint32_t *pfRetEvents)
 {
-    PRTVFSMEMFILE pThis = (PRTVFSMEMFILE)pvThis;
-    int           rc;
-
+    int rc;
     if (fEvents != RTPOLL_EVT_ERROR)
     {
Index: trunk/src/VBox/Runtime/common/vfs/vfsstdfile.cpp
===================================================================
--- trunk/src/VBox/Runtime/common/vfs/vfsstdfile.cpp	(revision 39029)
+++ trunk/src/VBox/Runtime/common/vfs/vfsstdfile.cpp	(revision 39032)
@@ -253,7 +253,5 @@
                                               uint32_t *pfRetEvents)
 {
-    PRTVFSSTDFILE pThis = (PRTVFSSTDFILE)pvThis;
-    int           rc;
-
+    int rc;
     if (fEvents != RTPOLL_EVT_ERROR)
     {
@@ -345,6 +343,6 @@
 static DECLCALLBACK(int) rtVfsStdFile_SetOwner(void *pvThis, RTUID uid, RTGID gid)
 {
-    PRTVFSSTDFILE pThis = (PRTVFSSTDFILE)pvThis;
 #if 0
+    PRTVFSSTDFILE pThis = (PRTVFSSTDFILE)pvThis;
     return RTFileSetOwner(pThis->hFile, uid, gid);
 #else
Index: trunk/src/VBox/Runtime/common/zip/gzipvfs.cpp
===================================================================
--- trunk/src/VBox/Runtime/common/zip/gzipvfs.cpp	(revision 39029)
+++ trunk/src/VBox/Runtime/common/zip/gzipvfs.cpp	(revision 39032)
@@ -511,5 +511,4 @@
              *        be handed on to zlib later on.
              */
-            size_t cbRead = 0;
             rc = RTVfsIoStrmRead(pThis->hVfsIos, pThis->abBuffer, sizeof(RTZIPGZIPHDR), true /*fBlocking*/, NULL /*pcbRead*/);
             if (RT_SUCCESS(rc))
Index: trunk/src/VBox/Runtime/common/zip/tar.cpp
===================================================================
--- trunk/src/VBox/Runtime/common/zip/tar.cpp	(revision 39029)
+++ trunk/src/VBox/Runtime/common/zip/tar.cpp	(revision 39032)
@@ -599,5 +599,4 @@
         uint64_t cbAllWritten = 0; /* Already copied */
         uint64_t cbRead       = 0; /* Actually read in the last step */
-        uint64_t cbWrite      = 0; /* Actually write in the last step */
         for (;;)
         {