Index: /trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_de.ts
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_de.ts	(revision 39187)
+++ /trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_de.ts	(revision 39188)
@@ -4575,4 +4575,8 @@
     </message>
     <message>
+        <source>&lt;p&gt;You have version %1 of the &lt;b&gt;&lt;nobr&gt;%2&lt;/nobr&gt;&lt;/b&gt; installed.&lt;/p&gt;&lt;p&gt;You should download and install version %3 of this extension pack from Oracle!&lt;/p&gt;</source>
+        <translation>&lt;p&gt;Sie haben Version %1 des &lt;b&gt;&lt;nobr&gt;%2&lt;/nobr&gt;&lt;/b&gt; installiert.&lt;/p&gt;&lt;p&gt;Sie sollten Version %3 dieses Zusatzpaketes von Oracle herunterladen und installieren!&lt;/p&gt;</translation>
+    </message>
+    <message>
         <source>&lt;p&gt;Are you sure you want to download the &lt;b&gt;&lt;nobr&gt;%1&lt;/nobr&gt;&lt;/b&gt; from &lt;nobr&gt;&lt;a href=&quot;%2&quot;&gt;%2&lt;/a&gt;&lt;/nobr&gt; (size %3 bytes)?&lt;/p&gt;</source>
         <translation>&lt;p&gt;Möchten Sie wirklich das &lt;b&gt;&lt;nobr&gt;%1&lt;/nobr&gt;&lt;/b&gt; von &lt;nobr&gt;&lt;a href=&quot;%2&quot;&gt;%2&lt;/a&gt;&lt;/nobr&gt; (Größe %3 Byte) herunterladen?&lt;/p&gt;</translation>
Index: /trunk/src/VBox/Frontends/VirtualBox/src/globals/UIMessageCenter.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/globals/UIMessageCenter.cpp	(revision 39187)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/globals/UIMessageCenter.cpp	(revision 39188)
@@ -1832,4 +1832,17 @@
 }
 
+bool UIMessageCenter::requestUserDownloadExtensionPack(const QString &strExtPackName, const QString &strExtPackVersion, const QString &strVBoxVersion)
+{
+    return message(mainWindowShown(), Info,
+                   tr("<p>You have version %1 of the <b><nobr>%2</nobr></b> installed.</p>"
+                      "<p>You should download and install version %3 of this extension pack from Oracle!</p>")
+                      .arg(strExtPackVersion).arg(strExtPackName).arg(strVBoxVersion),
+                      0, /* Auto-confirm Id */
+                      QIMessageBox::Ok | QIMessageBox::Default,
+                      0,
+                      0,
+                      tr("Ok", "extension pack"));
+}
+
 bool UIMessageCenter::confirmDownloadExtensionPack(const QString &strExtPackName, const QString &strURL, qulonglong uSize)
 {
Index: /trunk/src/VBox/Frontends/VirtualBox/src/globals/UIMessageCenter.h
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/globals/UIMessageCenter.h	(revision 39187)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/globals/UIMessageCenter.h	(revision 39188)
@@ -311,4 +311,5 @@
 
     bool proposeDownloadExtensionPack(const QString &strExtPackName, const QString &strExtPackVersion);
+    bool requestUserDownloadExtensionPack(const QString &strExtPackName, const QString &strExtPackVersion, const QString &strVBoxVersion);
     bool confirmDownloadExtensionPack(const QString &strExtPackName, const QString &strURL, qulonglong uSize);
     bool proposeInstallExtentionPack(const QString &strExtPackName, const QString &strFrom, const QString &strTo);
Index: /trunk/src/VBox/Frontends/VirtualBox/src/net/UIUpdateManager.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/net/UIUpdateManager.cpp	(revision 39187)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/net/UIUpdateManager.cpp	(revision 39188)
@@ -136,5 +136,6 @@
 
     /* Get VirtualBox version: */
-    VBoxVersion vboxVersion(vboxGlobal().vboxVersionStringNormalized());
+    QString strVBoxVersion(vboxGlobal().vboxVersionStringNormalized());
+    VBoxVersion vboxVersion(strVBoxVersion);
     /* Get extension pack version: */
     QString strExtPackVersion(extPack.GetVersion().remove(VBOX_BUILD_PUBLISHER));
@@ -145,7 +146,15 @@
         return;
 
-    /* Ask the user about extension pack downloading: */
-    if (!msgCenter().proposeDownloadExtensionPack(UI_ExtPackName, strExtPackVersion))
-        return;
+    if (strExtPackVersion.contains("ENTERPRISE"))
+    {
+        /* Inform the user that he should update the extension pack: */
+        msgCenter().requestUserDownloadExtensionPack(UI_ExtPackName, strExtPackVersion, strVBoxVersion);
+    }
+    else
+    {
+        /* Ask the user about extension pack downloading: */
+        if (!msgCenter().proposeDownloadExtensionPack(UI_ExtPackName, strExtPackVersion))
+            return;
+    }
 
     /* Run downloader for VirtualBox extension pack: */